summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2006-06-08 20:13:37 +0000
committerJim Meyering <jim@meyering.net>2006-06-08 20:13:37 +0000
commit790892db657ac79b0ba5f7a69cc7e70eb4fed8e0 (patch)
tree6d768a6a1af6cab8a813c1173dddc93c352f4751 /tests
parentcad27cdc2ea46ec401b71b76a92fcf3bc1d094e0 (diff)
downloadcoreutils-790892db657ac79b0ba5f7a69cc7e70eb4fed8e0.tar.xz
Ensure that cat works with any of the options, -A -v -e -E -T,
when applied to files in /proc and /sys, even when the FIONREAD ioctl produces nonsensical results. Before this change, cat would produce no output (or truncated output), for some linux kernels. * src/cat.c (write_pending): New function, factored out of cat. (cat): Also interpret a negative ioctl/FIONREAD count as indicating that there are bytes to read. Some versions of linux-2.6.16 do that. Write any pending output before returning. Reported by Dan Jacobson in <http://bugs.debian.org/370583>. * NEWS: Mention this bug fix. * tests/misc/cat-proc: New file. Test for the above. * tests/misc/Makefile.am (TESTS): Add cat-proc.
Diffstat (limited to 'tests')
-rw-r--r--tests/misc/Makefile.am1
-rwxr-xr-xtests/misc/cat-proc42
2 files changed, 43 insertions, 0 deletions
diff --git a/tests/misc/Makefile.am b/tests/misc/Makefile.am
index 5f6b07a92..696b9fdc1 100644
--- a/tests/misc/Makefile.am
+++ b/tests/misc/Makefile.am
@@ -18,6 +18,7 @@ TESTS_ENVIRONMENT = \
# will execute the test script rather than the standard utility.
TESTS = \
+ cat-proc \
base64 \
basename \
close-stdout \
diff --git a/tests/misc/cat-proc b/tests/misc/cat-proc
new file mode 100755
index 000000000..69e206514
--- /dev/null
+++ b/tests/misc/cat-proc
@@ -0,0 +1,42 @@
+#!/bin/sh
+# Ensure that cat -E produces same output as cat, module `$'s,
+# even when applied to a file in /proc.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cat --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+f=/proc/cpuinfo
+test -f $f \
+ || {
+ echo "$0: no $f skipping this test" 1>&2
+ (exit 77); exit 77
+ }
+
+fail=0
+
+# Yes, parts of /proc/cpuinfo might change between cat runs.
+# If that happens, consider choosing a file that's less likely to change,
+# or just filter out the changing lines.
+cat -E $f | tr -d '$' > out || fail=1
+cat $f | tr -d '$' > exp || fail=1
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail